package gp_dbc.commands;

import JinRyuu.JRMCore.server.JGPlayerMP;
import com.forgeessentials.api.UserIdent;
import gp_dbc.Main;
import net.minecraft.command.ICommand;
import net.minecraft.command.ICommandSender;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.server.MinecraftServer;
import net.minecraft.server.dedicated.DedicatedServer;
import net.minecraft.util.ChatComponentText;
import net.minecraft.util.EnumChatFormatting;
import net.minecraft.world.World;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

import static com.forgeessentials.core.commands.ForgeEssentialsCommandBase.getListOfStringsMatchingLastWord;

public class CommandGP implements ICommand {

    private final List aliases;
    public static HashMap<String, Integer> commands = new HashMap();
    public static final String[] COMMANDS = {"addGP", "removeGP", "inmate", "freeInmate", "removeJail"};

    public CommandGP() {
        aliases = new ArrayList();
        aliases.add("galacticpatrol");
        aliases.add("gp");

    }

    @Override
    public String getCommandName() {
        return "galacticpatrol";
    }

    @Override
    public String getCommandUsage(ICommandSender p_71518_1_) {
        return "gp <text> [<player>]";
    }

    @Override
    public List getCommandAliases() {
        return this.aliases;
    }

    @Override
    public void processCommand(ICommandSender sender, String[] argString) {

        EntityPlayer player = null;
        String arg;
        List<String> args = new ArrayList<>();

        if (argString.length == 0) {
            sender.addChatMessage(new ChatComponentText(EnumChatFormatting.RED + "/gp <text> [<player>]"));
            return;
        }
        else if (argString.length == 1) {
            if (sender instanceof EntityPlayer)
                player = (EntityPlayer) sender;
            else {
                sender.addChatMessage(new ChatComponentText(EnumChatFormatting.RED + "/gp <text> [<player>]"));
                return;
            }
        }
        else {
            player = UserIdent.getPlayerByMatchOrUsername(sender, argString[argString.length - 1]);

            if (player == null) {
                for (int i = 1; i < argString.length; i++)
                    args.add(argString[i]);

                if (sender instanceof EntityPlayer)
                    player = (EntityPlayer) sender;
                else {
                    sender.addChatMessage(new ChatComponentText(EnumChatFormatting.RED + "Player not found"));
                    return;
                }
            }
            else
                for (int i = 1; i < argString.length - 1; i++)
                    args.add(argString[i]);
        }
        arg = argString[0];

        JGPlayerMP jgPlayer = new JGPlayerMP(player);
        jgPlayer.connectBaseNBT();

        if (arg.equals(COMMANDS[0])) // Add
            Main.gp.addToGalaticPatrol(player, true);
        else if (arg.equals(COMMANDS[1])) // Remove
            Main.gp.removeFromGalaticPatrol(player, true);
        else if (arg.equals(COMMANDS[2])) { // Inmate
            if (args.size() != 1)
                sender.addChatMessage(new ChatComponentText(EnumChatFormatting.RED + "/gp jail sec [<player>]"));
            else {
                try {
                    Main.gp.jail.putPlayerInJail(sender, player, Long.parseLong(args.get(0)), true);
                } catch (Exception e) {
                    sender.addChatMessage(new ChatComponentText(EnumChatFormatting.RED + "/gp jail sec [<player>]"));
                }
            }
        }
        else if (arg.equals(COMMANDS[3])) { // freeInmate
            Main.gp.jail.removePlayerFromJail(sender, player, true);
        }
        else if (arg.equals(COMMANDS[4])) {// RemoveJail
            if (args.size() != 4)
                sender.addChatMessage(new ChatComponentText(EnumChatFormatting.RED + "/gp removeJail <x> <y> <z> <dimension>"));
            else {
                try {
                    if (Main.gp.jail.removeCell(Integer.parseInt(args.get(0)), Integer.parseInt(args.get(1)), Integer.parseInt(args.get(2)), Integer.parseInt(args.get(3))))
                        sender.addChatMessage(new ChatComponentText(EnumChatFormatting.GREEN + "Cell removed"));
                    else
                        sender.addChatMessage(new ChatComponentText(EnumChatFormatting.RED + "Cell doesn't exist"));
                } catch (Exception e) {
                    sender.addChatMessage(new ChatComponentText(EnumChatFormatting.RED + "/gp removeJail <x> <y> <z> <dimension> [<player>]"));
                }
            }
        }
        else
            sender.addChatMessage(new ChatComponentText(EnumChatFormatting.RED.toString() + EnumChatFormatting.UNDERLINE.toString() + "Galactic Patrol:"
                    + EnumChatFormatting.RESET.toString() + EnumChatFormatting.RED.toString() + " Command not found"));
    }

    @Override
    public boolean canCommandSenderUseCommand(ICommandSender sender) {
        if (sender instanceof EntityPlayer)
            return sender.canCommandSenderUseCommand(4, "");
        return true;
    }

    @Override
    public List<?> addTabCompletionOptions(ICommandSender sender, String[] strArray) {
        List<String> strListComp = new ArrayList<String>();

        List<EntityPlayer> listPlayer = MinecraftServer.getServer().getConfigurationManager().playerEntityList;

        if (strArray.length > 1)
            for (EntityPlayer player : listPlayer)
                strListComp.add(player.getDisplayName());
        else if (strArray.length == 1)
            return getListOfStringsMatchingLastWord(strArray, commands.keySet());

        return strListComp;
    }

    @Override
    public boolean isUsernameIndex(String[] p_82358_1_, int p_82358_2_) {
        return false;
    }

    @Override
    public int compareTo(Object o) {
        return 0;
    }

    static {
        for (int i = 0; i < COMMANDS.length; i++)
            commands.put(COMMANDS[i], i + 1);
    }
}
